package com.zhilian.business.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zhilian.business.domain.Fence;
import com.zhilian.business.mapper.FenceMapper;
import com.zhilian.business.service.FenceService;
import com.zhilian.common.core.utils.StringUtils;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class FenceServiceImpl extends ServiceImpl<FenceMapper, Fence> implements FenceService {
    @Override
    public List<Fence> fenceList(Fence fence) {
        if (fence.getFenceName() == null && fence.getFenceTypeId() == null && fence.getFenceState() == null) {
            return this.list();
        }

        LambdaQueryWrapper<Fence> queryWrapper = new LambdaQueryWrapper<>();

        // 模糊条件 - 电子围栏名称
        if (StringUtils.isNotEmpty(fence.getFenceName())) {
            queryWrapper.like(Fence::getFenceName, fence.getFenceName());
        }

        // 精确查询 - 查询类型
        if (fence.getFenceTypeId() != null) {
            queryWrapper.eq(Fence::getFenceTypeId, fence.getFenceTypeId());
        }

        // 模糊查询 - 状态
        if (fence.getFenceState() != null) {
            queryWrapper.eq(Fence::getFenceState, fence.getFenceState());
        }

        return this.list(queryWrapper);
    }
}
