package com.zhilian.business.service.impl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zhilian.business.domain.Vehicle;
import com.zhilian.business.domain.middle.VehicleMarkers;
import com.zhilian.business.mapper.VehicleMarkersMapper;
import com.zhilian.business.service.VehicleMarkersService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

@Service
public class VehicleMarkersServiceImpl extends ServiceImpl<VehicleMarkersMapper, VehicleMarkers> implements VehicleMarkersService {

    @Transactional(rollbackFor=Exception.class)
    @Override
    public boolean insert(Vehicle vehicle) {
        ArrayList<VehicleMarkers> list = new ArrayList<>();
        vehicle.getMarkersIds().forEach(markerId -> {
            VehicleMarkers vehicleMarkers = new VehicleMarkers();
            vehicleMarkers.setVehicleId(vehicle.getVehicleId());
            vehicleMarkers.setMarkersId(markerId);
            list.add(vehicleMarkers);
        });
        return this.saveBatch(list);
    }

    @Override
    public void removeAllVehicle(Vehicle vehicle) {
        List<VehicleMarkers> list = this.list(new LambdaQueryWrapper<VehicleMarkers>().eq(VehicleMarkers::getVehicleId, vehicle.getVehicleId()));
        this.removeByIds(list);
    }
}
